﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Excel123 {
    public class ModelEmployee : IComparable {

        public ModelEmployee(int pindex, String firstname, String lastname, String street, String zipcode, String city, String country, decimal monthlysalary, String mobile) {
            this.pindex = pindex;
            this.firstname = firstname;
            this.lastname = lastname;
            this.zipcode = zipcode;
            this.street = street;
            this.city = city;
            this.country = country;
            this.monthlysalary = monthlysalary;
            this.mobile = mobile;
        }



        private int pindex = -1;
        public int Pindex {
            get {
                return pindex;
            }
            set {
                if (value != pindex) {
                    pindex = value;
                }
            }
        }

        private int nr;
        public int Nr {
            get { return nr; }
            set { nr = value; }
        }

        private String firstname;
        public String Firstname {
            get {
                return firstname;
            }
            set {
                if (value != firstname) {
                    firstname = value;
                }
            }
        }


        private String lastname;
        public String Lastname {
            get {
                return lastname;
            }
            set {
                if (value != lastname) {
                    lastname = value;
                }
            }
        }

        private String zipcode;
        public String Zipcode {
            get {
                return zipcode;
            }
            set {
                if (value != zipcode) {
                    zipcode = value;
                }
            }
        }


        private String city;
        public String City {
            get {
                return city;
            }
            set {
                if (value != city) {
                    city = value;
                }
            }
        }


        private String street;
        public String Street {
            get {
                return street;
            }
            set {
                if (value != lastname) {
                    street = value;
                }
            }
        }

        private String country;
        public String Country {
            get {
                return country;
            }
            set {
                if (value != lastname) {
                    country = value;
                }
            }
        }


        private decimal monthlysalary;
        public decimal Monthlysalary {
            get {
                return monthlysalary;
            }
            set {
                if (value != monthlysalary) {
                    monthlysalary = value;
                    Yearsalary = monthlysalary * 12.0m;
                }
            }
        }


        // muss vorhanden sein, für die Datagrid
        private decimal yearsalary;
        public decimal Yearsalary {
            get {
                return yearsalary;
            }
            set {
                if (value != yearsalary) {
                    yearsalary = value;
                    monthlysalary = yearsalary / 12.0m;
                }
            }
        }


        private String mobile;
        public String Mobile {
            get {
                return mobile;
            }
            set {
                if (value != mobile) {
                    mobile = value;
                }
            }
        }



        public int CompareTo(object obj) {
            ModelEmployee empl = (ModelEmployee)obj;
            int i = lastname.CompareTo(empl.lastname);
            if (i != 0)
                return i;
            else
                return firstname.CompareTo(empl.firstname);
        }



        public override String ToString() {
            return lastname + "   " + firstname;
        }


        // Excel Export, header
        public static String[] CaptionItemArray {
            get {
                String[] items = new String[9];
                items[0] = "Firstname";
                items[1] = "Lastname";
                items[2] = "Montlysalary";
                items[3] = "Yearlysalary";

                items[4] = "Street";
                items[5] = "Zipcode";
                items[6] = "City";
                items[7] = "Country";
                items[8] = "Mobile";

                return items;
            }
        }

        // excel per row
        public Object[] ItemArray {
            get {
                Object[] items = new Object[9];
                items[0] = firstname;
                items[1] = lastname;
                items[2] = monthlysalary;
                items[3] = yearsalary;
                items[4] = street;
                items[5] = zipcode;
                items[6] = city;
                items[7] = country;
                items[8] = mobile;

                return items;
            }
        }
       

        public void insertinItemArray(int row, ref Object[,] items) {
            items[row, 0] = firstname;
            items[row, 1] = lastname;
            items[row, 2] = monthlysalary;
            items[row, 3] = yearsalary;
            items[row, 4] = street;
            items[row, 5] = zipcode;
            items[row, 6] = city;
            items[row, 7] = country;
            items[row, 8] = mobile;
        }





    }
}
